Framework BRL.Basic
Import BRL.Retro
Import Pub.Lua
Import BRL.Event
Import BRL.EventQueue
Import BRL.Timer
Import MaxGUI.Drivers

Global ls:Byte Ptr = luaL_newstate()
luaL_openlibs(ls)
luaopen_socket_core(ls)

Const WIN_WIDTH = 520
Const WIN_HEIGHT = 420

AppTitle = "Starkkz's IRC"
Global app_window:TGadget = CreateWindow("Starkkz's IRC", 0, 0, WIN_WIDTH, WIN_HEIGHT, Null, WINDOW_TITLEBAR|WINDOW_CLOSE|WINDOW_RESIZABLE|WINDOW_CENTER)
Global app_tab:TGadget = CreateTabber(5, 10, 490, 25, app_window)
AddGadgetItem app_tab, "Input"
AddGadgetItem app_tab, "Bot"
AddGadgetItem app_tab, "User list"
AddGadgetItem app_tab, "Channels"

' Server input/output
Global input_panel:TGadget = CreatePanel(5, 40, 490, 350, app_window, PANEL_SUNKEN|PANEL_RAISED, "Input")
Global app_output:TGadget = CreateTextArea(5, 10, 475, 230, input_panel, TEXTAREA_READONLY)
Global app_input:TGadget = CreateTextField(5, 270, 475, 25, input_panel)
Global app_button:TGadget = CreateButton("Execute script", 5, 300, 100, 25, input_panel, BUTTON_PUSH|BUTTON_OK)

Global label_linput:TGadget = CreateLabel("Lua input", 10, 250, 100, 25, input_panel)
CreateTimer(1000)

' Bot panel
Global bot_panel:TGadget = CreatePanel(5, 40, 490, 350, app_window, PANEL_SUNKEN|PANEL_RAISED, "Bot")
Global input_bot_script:TGadget = CreateTextArea(230, 40, 250, 280, bot_panel)
Global input_bot_name:TGadget = CreateTextField(10, 40, 200, 25, bot_panel)
Global input_bot_chan:TGadget = CreateTextField(10, 90, 200, 25, bot_panel)
Global button_bot_add:TGadget = CreateButton("Add bot", 50, 120, 100, 25, bot_panel)
HideGadget(bot_panel)

Global label_botname:TGadget = CreateLabel("Bot name", 10, 20, 100, 25, bot_panel)
Global label_botchannel:TGadget = CreateLabel("Channel", 10, 70, 100, 25, bot_panel)
SetGadgetFilter(input_bot_name, AntiSpaceFilter, input_bot_name)
SetGadgetFilter(input_bot_chan, ChanFilter, input_bot_chan)
init_botscript()

' User panel
Global user_panel:TGadget = CreatePanel(5, 40, 490, 350, app_window, PANEL_SUNKEN|PANEL_RAISED, "User list")
Global listbox_user_list:TGadget = CreateListBox(5, 10, 200, 250, user_panel)
Global button_kick:TGadget = CreateButton("Kick", 230, 10, 100, 25, user_panel)
Global button_setop:TGadget = CreateButton("Set operator", 230, 40, 100, 25, user_panel)
Global button_takeop:TGadget = CreateButton("Take operator", 230, 70, 100, 25, user_panel)
HideGadget(user_panel)

' Channels
Global channel_panel:TGadget = CreatePanel(5, 40, 490, 350, app_window, PANEL_SUNKEN|PANEL_RAISED, "Channels")
Global listbox_chan_list:TGadget = CreateListBox(5, 10, 200, 220, channel_panel)
Global listbox_chan_userlist:TGadget = CreateListBox(210, 10, 200, 220, channel_panel)
Global button_channel_close:TGadget = CreateButton("Close channel", 10, 240, 150, 25, channel_panel)
Global button_channel_kick:TGadget = CreateButton("Kick", 205, 240, 100, 25, channel_panel)
Global button_channel_ban:TGadget = CreateButton("Ban", 310, 240, 100, 25, channel_panel)
Global button_channel_setop:TGadget = CreateButton("Set operator", 205, 270, 100, 25, channel_panel)
Global button_channel_takeop:TGadget = CreateButton("Take operator", 310, 270, 100, 25, channel_panel)
HideGadget(channel_panel)

Function GadgetScaleX:Float()
	Return Float(GadgetWidth(app_window))/Float(WIN_WIDTH)
EndFunction

Function GadgetScaleY:Float()
	Return Float(GadgetHeight(app_window))/Float(WIN_HEIGHT)
EndFunction

Function ReshapeGadgets()
	Local sx:Float = GadgetScaleX()
	Local sy:Float = GadgetScaleY()
	SetGadgetShape app_tab, 5*sx, 10*sy, 490, 25
	SetGadgetShape input_panel, 5*sx, 40*sy, 490*sx, 350*sy
	SetGadgetShape app_output, 5*sx, 10*sy, 475*sx, 230*sy
	SetGadgetShape app_input, 5*sx, 270*sy, 475*sx, 25*sy
	SetGadgetShape app_button, 5*sx, 300*sy, 100*sx, 25*sy
	SetGadgetShape label_linput, 10*sx, 250*sy, 100*sx, 25*sy
	SetGadgetShape bot_panel, 5*sx, 40*sy, 490*sx, 350*sy
	SetGadgetShape input_bot_script, 230*sx, 40*sy, 230*sx, 280*sy
	SetGadgetShape input_bot_name, 10*sx, 40*sy, 200*sx, 25*sy
	SetGadgetShape input_bot_chan, 10*sx, 90*sy, 200*sx, 25*sy
	SetGadgetShape button_bot_add, 50*sx, 120*sy, 100*sx, 25*sy
	SetGadgetShape label_botname, 10*sx, 20*sy, 100*sx, 25*sy
	SetGadgetShape label_botchannel, 10*sx, 70*sy, 100*sx, 25*sy
	SetGadgetShape user_panel, 5*sx, 40*sy, 490*sx, 350*sy
	SetGadgetShape listbox_user_list, 5*sx, 10*sy, 200*sx, 250*sy
	SetGadgetShape button_kick, 230*sx, 10*sy, 100*sx, 25*sy
	SetGadgetShape button_setop, 230*sx, 40*sy, 100*sx, 25*sy
	SetGadgetShape button_takeop, 230*sx, 70*sy, 100*sx, 25*sy
	SetGadgetShape channel_panel, 5*sx, 40*sy, 490*sx, 350*sy
	SetGadgetShape listbox_chan_list, 5*sx, 10*sy, 200*sx, 220*sy
	SetGadgetShape listbox_chan_userlist, 210*sx, 10*sy, 200*sx, 220*sy
	SetGadgetShape button_channel_close, 10*sx, 240*sy, 150*sx, 25*sy
	SetGadgetShape button_channel_kick, 205*sx, 240*sy, 100*sx, 25*sy
	SetGadgetShape button_channel_ban, 310*sx, 240*sy, 100*sx, 25*sy
	SetGadgetShape button_channel_setop, 205*sx, 270*sy, 100*sx, 25*sy
	SetGadgetShape button_channel_takeop, 310*sx, 270*sy, 100*sx, 25*sy
EndFunction

lua_register(ls, "print", lua_print)
If luaL_dofile(ls, "server.lua") Then
	lua_err(ls)
EndIf

Repeat
	WaitEvent()
	Select EventID()
		Case EVENT_WINDOWSIZE
			Select EventSource()
				Case app_window
					ReshapeGadgets()
			EndSelect
		Case EVENT_TIMERTICK
			update_app()
		Case EVENT_GADGETSELECT
			Select EventSource()
				Case listbox_chan_list
					update_channel_userlist()
			EndSelect
		Case EVENT_GADGETACTION
			Select EventSource()
				Case app_button
					parse_input()
				Case app_tab
					Select EventData()
						Case 3
							update_channel_list()
							update_channel_userlist()
							HideGadget input_panel
							HideGadget bot_panel
							HideGadget user_panel
							ShowGadget channel_panel
						Case 2
							update_user_list()
							HideGadget input_panel
							HideGadget bot_panel
							ShowGadget user_panel
							HideGadget channel_panel
						Case 1
							HideGadget input_panel
							ShowGadget bot_panel
							HideGadget user_panel
							HideGadget channel_panel
						Case 0
							ShowGadget input_panel
							HideGadget bot_panel
							HideGadget user_panel
							HideGadget channel_panel
					EndSelect
				Case button_bot_add
					parse_new_bot()
				Case button_kick
					gui_client_kick()
				Case button_setop
					gui_client_setop()
				Case button_takeop
					gui_client_takeop()
				Case button_channel_close
					gui_channel_close()
					update_channel_list()
					update_channel_userlist()
				Case button_channel_kick
					gui_channel_kick()
					update_channel_list()
				Case button_channel_ban
					gui_channel_ban()
				Case button_channel_setop
					gui_channel_setop()
				Case button_channel_takeop
					gui_channel_takeop()
			EndSelect
		Case EVENT_WINDOWCLOSE
			End
	EndSelect
Forever

' User functions
Function gui_selected_user$()
	Local id = SelectedGadgetItem(listbox_user_list)
	If id = -1 Then Return ""
	Return GadgetItemText(listbox_user_list, id)
EndFunction

Function gui_client_kick()
	Local name$ = gui_selected_user()
	If Len(name) > 0 Then
		Local id = get_client_id(name)
		
		If id <> -1 Then
			If luaL_dostring(ls, "irc_server.client_cmd("+id+",~qQUIT~q,~qDisconnected~q)") = 1 Then
				lua_err(ls)
			EndIf
			update_user_list()
		EndIf
	EndIf
EndFunction

Function gui_client_takeop()
	Local name$ = gui_selected_user()
	If Len(name) > 0 Then
		Local id = get_client_id(name)
		
		If id <> -1 Then
			If luaL_dostring(ls, "irc_client["+id+"].op = false") = 1 Then
				lua_err(ls)
			EndIf
		EndIf
	EndIf
EndFunction

Function gui_client_setop()
	Local name$ = gui_selected_user()
	If Len(name) > 0 Then
		Local id = get_client_id(name)
		
		If id <> -1 Then
			If luaL_dostring(ls, "irc_client["+id+"].op = true") = 1 Then
				lua_err(ls)
			EndIf
		EndIf
	EndIf
EndFunction

Function parse_input()
	Local in$ = GadgetText(app_input)
	SetGadgetText(app_input, "")

	If luaL_dostring(ls, in) Then
		lua_err(ls)
	EndIf
EndFunction

Function get_client_name$(id)
	lua_settop(ls, 0)
	lua_getglobal(ls, "user_nick")
	
	lua_pushinteger(ls, id)
	If lua_pcall(ls, 1, 1, 0) = 1 Then
		lua_err(ls)
	Else
		Return lua_tostring(ls, 1)
	EndIf
	Return -1
EndFunction

Function get_client_id(nick$)
	lua_settop(ls, 0)
	lua_getglobal(ls, "user_id")

	lua_pushstring(ls, nick)
	If lua_pcall(ls, 1, 1, 0) = 1 Then
		lua_err(ls)
	Else
		Return lua_tointeger(ls, 1)
	EndIf
	Return -1
EndFunction

Function update_user_list()
	ClearGadgetItems listbox_user_list

	lua_settop(ls, 0)
	lua_getglobal(ls, "irc_client")
	
	If lua_istable(ls, -1) Then
		lua_pushnil(ls)
		While lua_next(ls, -2) <> Null
			lua_pushstring(ls, "nick")
			lua_gettable(ls, -2)
			
			Local nick$ = lua_tostring(ls, -1)
			lua_pop(ls, 2)
			
			AddGadgetItem listbox_user_list, nick
		Wend
		lua_pop(ls, 1)
	EndIf
EndFunction

' Channel functions
Function gui_selected_channel_user$()
	Local id = SelectedGadgetItem(listbox_chan_userlist)
	If id = -1 Then Return ""
	Return GadgetItemText(listbox_chan_userlist, id)
EndFunction

Function gui_selected_channel$()
	Local id = SelectedGadgetItem(listbox_chan_list)
	If id = -1 Then Return ""
	Return GadgetItemText(listbox_chan_list, id)
EndFunction

Function gui_channel_close()
	Local name$ = gui_selected_channel()
	If Len(name) > 0 Then
		If luaL_dostring(ls, "irc_server.channels[~q"+name+"~q]:close()") = 1 Then
			lua_err(ls)
		EndIf
	EndIf
EndFunction

Function gui_channel_kick()
	Local user_name$ = gui_selected_channel_user()
	Local channel_name$ = gui_selected_channel()
	If Len(user_name) > 0 And Len(channel_name) > 0 Then
		Local user_id = get_client_id(user_name)
		If user_id <> -1 Then
			If luaL_dostring(ls, "irc_server.channels[~q"+channel_name+"~q]:kick("+user_id+")") = 1 Then
				lua_err(ls)
			Else
				'update_channel_userlist()
				For i = 0 To listbox_chan_userlist.items.length-1
					Local g:TGadgetItem = listbox_chan_userlist.items[i]
					If g.text = user_name Then
						RemoveGadgetItem listbox_chan_userlist, i
						Exit
					EndIf
				Next
			EndIf
		EndIf
	EndIf
EndFunction

Function gui_channel_ban()
	Local user_name$ = gui_selected_channel_user()
	Local channel_name$ = gui_selected_channel()
	If Len(user_name) > 0 And Len(channel_name) > 0 Then
		Local user_id = get_client_id(user_name)
		If user_id <> -1 Then
			If luaL_dostring(ls, "irc_server.channels[~q"+channel_name+"~q]:setmode("+user_id+",~qb+~q)") = 1 Then
				lua_err(ls)
			EndIf
		EndIf
	EndIf
EndFunction

Function gui_channel_setop()
	Local user_name$ = gui_selected_channel_user()
	Local channel_name$ = gui_selected_channel()
	If Len(user_name) > 0 And Len(channel_name) > 0 Then
		Local user_id = get_client_id(user_name)
		If user_id <> -1 Then
			If luaL_dostring(ls, "irc_server.channels[~q"+channel_name+"~q]:setmode("+user_id+",~q+o~q)") = 1 Then
				lua_err(ls)
			EndIf
		EndIf
	EndIf
EndFunction

Function gui_channel_takeop()
	Local user_name$ = gui_selected_channel_user()
	Local channel_name$ = gui_selected_channel()
	If Len(user_name) > 0 And Len(channel_name) > 0 Then
		Local user_id = get_client_id(user_name)
		If user_id <> -1 Then
			If luaL_dostring(ls, "irc_server.channels[~q"+channel_name+"~q]:setmode("+user_id+",~q-o~q)") = 1 Then
				lua_err(ls)
			EndIf
		EndIf
	EndIf
EndFunction

Function update_channel_list()
	Local selected_channel = SelectedGadgetItem(listbox_chan_list)
	ClearGadgetItems listbox_chan_list
	
	lua_settop(ls, 0)
	lua_getglobal(ls, "irc_server")
	
	If lua_istable(ls, -1) Then
		lua_pushstring(ls, "channels")
		lua_gettable(ls, -2)
		If lua_istable(ls, -2) Then
			
			lua_pushnil(ls)
			While lua_next(ls, -2)
				Local name$ = lua_tostring(ls, -2)
				AddGadgetItem listbox_chan_list, name
				lua_pop(ls, 1)
			Wend
			lua_pop(ls, 1)
		EndIf
	EndIf
	If selected_channel <> -1 Then
		For Item:TGadgetItem = EachIn listbox_chan_list.Items
			SelectGadgetItem listbox_chan_list, selected_channel
			Exit
		Next
	EndIf
EndFunction

Function update_channel_userlist()
	Local selected_user = SelectedGadgetItem(listbox_chan_userlist)
	ClearGadgetItems listbox_chan_userlist
	
	Local name$ = gui_selected_channel()
	Local user_list:Int[]
	If Len(name) > 0 Then
		lua_settop(ls, 0)
		lua_getglobal(ls, "irc_server")
		
		If lua_istable(ls, -1) Then
			lua_pushstring(ls, "channels")
			lua_gettable(ls, -2)
			If lua_istable(ls, -2) Then
				lua_pushstring(ls, name)
				lua_gettable(ls, -2)
				
				lua_pushstring(ls, "user_list")
				lua_gettable(ls, -2)
				
				lua_pushnil(ls)
				While lua_next(ls, -2)
					Local id = lua_tointeger(ls, -2)
					Local idx = user_list.length
					user_list = user_list[..idx+1]
					user_list[idx] = id
					lua_pop(ls, 1)
				Wend
				lua_pop(ls, 1)
			EndIf
		EndIf
	EndIf
	For i = 0 To user_list.length-1
		AddGadgetItem listbox_chan_userlist, get_client_name(user_list[i])
	Next
	If selected_user <> -1 Then
		For Item:TGadgetItem = EachIn listbox_chan_userlist.Items
			SelectGadgetItem listbox_chan_userlist, selected_user
			Exit
		Next
	EndIf
EndFunction

Function parse_new_bot()
	Local bot_name$ = GadgetText(input_bot_name)
	Local bot_chan$ = GadgetText(input_bot_chan)
	
	If Len(bot_name) = 0 Then Return Notify("Please, insert bot name!")
	If Len(bot_chan) = 0 Then Return Notify("Please, insert channel name!")
	If Mid(bot_chan, 1, 1) <> "#" Then Return Notify("Cannot add bot to this channel!")
	
	lua_settop(ls, 0)
	lua_getglobal(ls, "irc_server")
	
	Local bot_id = -1
	If lua_istable(ls, -1) Then
		lua_pushstring(ls, "add_bot")
		lua_gettable(ls, -2)
		
		lua_pushstring(ls, bot_name)
		lua_pushstring(ls, bot_chan)
		
		If lua_pcall(ls, 2, 1, 0) Then
			lua_err(ls)
			Notify("Failed to add bot, please check console!", True)
		Else
			bot_id = lua_tointeger(ls, 2)
			update_user_list()
		EndIf
	EndIf
	
	If bot_id <> -1 Then
		Local script$ = GadgetText(input_bot_script)
		If Len(script) > 0 Then
			luaL_dostring(ls, "bot = irc_client["+bot_id+"]")
			If luaL_dostring(ls, script) = 0 Then
				luaL_dostring(ls, "bot = nil")
			Else
				lua_err(ls)
				Notify("Script error: please check console", True)
			EndIf
		EndIf
	Else
		Notify("Script error: unknown bot id", True)
	EndIf
EndFunction

Function init_botscript()
	Local s:TStream = ReadStream("bot_script.txt")
	If s Then
		SetGadgetText input_bot_script, ReadString(s, StreamSize(s))
		CloseStream s
	EndIf
EndFunction

' Lua functions
Function lua_err(L:Byte Ptr)
	Local err$ = lua_tostring(L, -1)
	If Len(err) > 0 Then
		AddTextAreaText app_output, "Lua Error: "+err+"~n"
	EndIf
EndFunction

Function lua_print(L:Byte Ptr)
	Local text$ = lua_tostring(L, 1)
	If Len(text) > 0 Then
		AddTextAreaText app_output, text+"~n"
	EndIf
EndFunction

Function update_app()
	lua_settop(ls, 0)
	lua_getglobal(ls, "irc_server")
	
	If lua_istable(ls, -1) Then
		lua_pushstring(ls, "update")
		lua_gettable(ls, -2)
		
		If lua_pcall(ls, 0, 0, 0) Then
			lua_err(ls)
		EndIf
	EndIf
EndFunction

' Textfield filters
Function AntiSpaceFilter(event:TEvent,context:Object)
	If event.id = EVENT_KEYCHAR Then
		If event.data = KEY_SPACE Then Return 0
	EndIf
	Return 1
EndFunction

Function ChanFilter(event:TEvent,context:Object)
	Local g:TGadget = TGadget(context)
	Local t$ = GadgetText(g)
	If event.id = EVENT_KEYCHAR Then
		If event.data = 35 Then
			If Len(t) = 0 Then
				Return 1
			EndIf
			Return 0
		ElseIf Len(t) = 0 Then
			Return 0
		EndIf
	EndIf
	Return 1
EndFunction